; (handcrafted file)

(set-logic QF_UFBV)

; tested with Z3, CVC4, Boolector

; 1000 seconds (~15 minutes) timeout:
; time z3 -T:1000 -smt2 1.smt
; time cvc4 --tlimit=1000000 --lang=smt2 1.smt
; time boolector -t 1000 --smt2 1.smt

; for CVC4 and Boolector, to enable (get-model):
; (set-option :produce-models true)

(declare-fun c0 () (_ BitVec 64)) (assert (= c0 (_ bv0 64))) ; always 0
(declare-fun c1 () (_ BitVec 64)) (assert (= c1 (_ bv1 64))) ; always 1

(declare-fun naive_x () (_ BitVec 64))
(declare-fun naive_out () (_ BitVec 64))

; popcount64(): naive way:
; (x>>0)&1 + (x>>1)&1 + (x>>2)&1 + ...

(assert (= naive_out
(bvadd 
       (bvand (bvlshr naive_x (_ bv0 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv1 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv2 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv3 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv4 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv5 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv6 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv7 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv8 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv9 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv10 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv11 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv12 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv13 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv14 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv15 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv16 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv17 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv18 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv19 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv20 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv21 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv22 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv23 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv24 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv25 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv26 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv27 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv28 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv29 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv30 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv31 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv32 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv33 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv34 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv35 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv36 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv37 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv38 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv39 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv40 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv41 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv42 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv43 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv44 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv45 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv46 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv47 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv48 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv49 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv50 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv51 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv52 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv53 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv54 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv55 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv56 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv57 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv58 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv59 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv60 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv61 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv62 64)) (_ bv1 64))
       (bvand (bvlshr naive_x (_ bv63 64)) (_ bv1 64))
)))

; constant array as UF:

(declare-fun f ((_ BitVec 64)) (_ BitVec 64))
(assert (= (f (_ bv0 64)) (_ bv0 64)))
(assert (= (f (_ bv1 64)) (_ bv1 64)))
(assert (= (f (_ bv2 64)) (_ bv1 64)))
(assert (= (f (_ bv3 64)) (_ bv2 64)))
(assert (= (f (_ bv4 64)) (_ bv1 64)))
(assert (= (f (_ bv5 64)) (_ bv2 64)))
(assert (= (f (_ bv6 64)) (_ bv2 64)))
(assert (= (f (_ bv7 64)) (_ bv3 64)))
(assert (= (f (_ bv8 64)) (_ bv1 64)))
(assert (= (f (_ bv9 64)) (_ bv2 64)))
(assert (= (f (_ bv10 64)) (_ bv2 64)))
(assert (= (f (_ bv11 64)) (_ bv3 64)))
(assert (= (f (_ bv12 64)) (_ bv2 64)))
(assert (= (f (_ bv13 64)) (_ bv3 64)))
(assert (= (f (_ bv14 64)) (_ bv3 64)))
(assert (= (f (_ bv15 64)) (_ bv4 64)))

(declare-fun f_x () (_ BitVec 64))
(declare-fun f_out () (_ BitVec 64))

;	rt=rt+f((x>>(0*4))&0xf);
;	rt=rt+f((x>>(1*4))&0xf);
;	...
(assert (= f_out
(bvadd
       (f (bvand (bvlshr f_x (_ bv0 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv4 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv8 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv12 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv16 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv20 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv24 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv28 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv32 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv36 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv40 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv44 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv48 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv52 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv56 64)) (_ bv15 64)))
       (f (bvand (bvlshr f_x (_ bv60 64)) (_ bv15 64)))
)))

; Boolector: 10s
; Z3: 16s
; CVC4: timeout
(assert (= naive_x f_x)) (assert (not (= naive_out f_out)))

(check-sat)
;(get-model)
